package bridge;

import framework.Console;

/**
 * This class provides a terminal console interface to the Bridge
 * Crossing problem.
 * Note that its function is entirely provided by the <b>Console</b>
 * class which is provided by the framework.
 * So you don't need the <b>BridgeConsole</b> class from the previous
 * assignment, and you don't have to add anything to this class.
 * @author tcolburn
 */
public class BridgeConsole {
    
    /**
     * This method launches the console.
     * @param args ignored
     */
    public static void main(String[] args) {
        Console console = new Console(new BridgeProblem());
        console.start();
    }
}
